// mensagem de abertura
#define MSG_TITULO "Algoritmos Geneticos - 5.1\n\n"

// semente inicial para o gerador de numeros aleatorios
#define SEMENTE_INICIAL 120

// numero de substituicoes que deve ocorrer antes do algoritmo parar
#define NUM_SUBSTITUICOES 4000

// numero de individuos que devem ser substituidos por novos de uma genaracao para outra
#define NUM_SUBS_INDIV 2

// numero de operadores diferentes disponiveis para uso pelo modulo de reproducao
#define NUM_OPERADORES 5

// tamanho da populacao (numero de cromossomos)
#define TAM_POP 100

// numero de bits num cromossomo
#define NUM_BITS 44

// um valor abaixo dos possiveis nas avaliacoes (usado para ordenacoes)
#define MUITO_PEQUENO -10000

// maior valor que pode ser sorteado para uso num campo de cromossomo: 2^22
#define MAIOR_PARA_SORTEIO ( 1 << ( NUM_BITS / 2 ) )


// parametros para adaptacao (fitness) de individuos da populacao

// valor inicial
#define VAL_INI_ADAPTACAO 100

// diferenca entre cada individuo
#define VAL_DESC_ADAPTACAO 1



// parametros na reproducao


// probabilidades dos operadores na reproducao

// probabilidade de executar crossover uniforme
#define PROB_CROSS_UNIF 0.8

// probabilidade de executar crossover pela media
#define PROB_CROSS_MEDIA 0.8

// probabilidade de executar mutacao
#define PROB_MUTAC 0.5

// probabilidade de executar gradiente 1 (creep)
#define PROB_GRAD_1 0.7

// probabilidade de executar gradiente 2 (creep)
#define PROB_GRAD_2 0.7

// parametros para adaptacao (fitness) dos operadores (soma dos valores deve dar 100)

// crossover uniforme
// valor inicial
#define VAL_INI_ADAPT_UNIF 10
// valor final
#define VAL_FIN_ADAPT_UNIF 10

// crossover media
// valor inicial
#define VAL_INI_ADAPT_MEDIA 40
// valor final
#define VAL_FIN_ADAPT_MEDIA 20

// mutacao
// valor inicial
#define VAL_INI_ADAPT_MUTA 10
// valor final
#define VAL_FIN_ADAPT_MUTA 0

// gradiente 1
// valor inicial
#define VAL_INI_ADAPT_GRAD_1 30
// valor final
#define VAL_FIN_ADAPT_GRAD_1 40

// gradiente 2
// valor inicial
#define VAL_INI_ADAPT_GRAD_2 10
// valor final
#define VAL_FIN_ADAPT_GRAD_2 30

// parametros para operador gradiente

// faixa de valores que pode ser sorteada para operador gradiente 1
#define FAIXA_VALS_GRAD_1 70000

// faixa de valores que pode ser sorteada para operador gradiente 2
#define FAIXA_VALS_GRAD_2 2000

