/* Funcoes de uso diverso */



#include <stdlib.h>
#include <stdio.h>

#include "defs.h"



/* Retorna 2 elevado a nExp
**********************************************************/
unsigned int RetPot2 ( int nExp )
{
   unsigned int
      uVal = 1;
   for ( int ncE = 0; ncE < nExp; ncE ++ )
      uVal *= 2;

   return uVal;
}



/* Exibe os bits de um cromossomo
pchCromo - aponta sequencia de bits (cromossomo) a ser exibido
********************************************************************/
void ExibeCromossomo ( char* pchCromo )
{
   for ( int ncB = 0; ncB < NUM_BITS; ncB ++ )
      printf ( "%d ", pchCromo [ ncB ] );
}



/* Converte a sequencia de bits de um cromossomo em 2 numeros
pchSeq - aponta sequencia de bits 
uX - primeiro numero
uY - segundo numero
**********************************************************/
void ConvBinVal ( char* pchSeq, unsigned int& uX, unsigned int& uY )
{
   uX = 0;       // recebe primeira metade de bits
   uY = 0;       // recebe segunda metade de bits

   // varre sequencia de bits e converte
   for ( int ncB = 0; ncB < NUM_BITS / 2; ncB ++ ) {
      uX += *( pchSeq + NUM_BITS / 2 - ncB - 1 ) << ncB;
      uY += *( pchSeq + NUM_BITS     - ncB - 1 ) << ncB;
   }
}



/* Converte 2 numeros na sequencia de bits de um cromossomo
uX - primeiro numero
uY - segundo numero
pchSeq - aponta sequencia de bits 
**********************************************************/
void ConvValBin ( unsigned int uX, unsigned int uY, char* pchSeq )
{
   // converte primeiro numero
   for ( int ncB = 0; ncB < NUM_BITS / 2; ncB ++ ) {
      *pchSeq = ( uX & RetPot2 ( NUM_BITS / 2 - ncB - 1 ) ) >> ( NUM_BITS / 2 - ncB - 1 );
      pchSeq ++;
   }

   // converte segundo numero
   for ( int ncB = 0; ncB < NUM_BITS / 2; ncB ++ ) {
      *pchSeq = ( uY & RetPot2 ( NUM_BITS / 2 - ncB - 1 ) ) >> ( NUM_BITS / 2 - ncB - 1 );
      pchSeq ++;
   }
}



/* Seleciona um valor.
Baseado em "Roulette Wheel".
uNumValores - quantos valores existem, numero de elementos em pfValores
pfValores - valores que determinam qual elemento selecionar
retorna indice do valor selecionado
**********************************************************/
unsigned int SelecionaValor ( unsigned int uNumValores, float* pfValores )
{
   // gera um numero entre 0 e soma total
   float
      fValorSelec = (float) ( rand () % (int) ( pfValores [ uNumValores - 1 ] ) );

   // procura um valor maior ou igual ao sorteado, se encontrar seleciona este individuo
   for ( unsigned int ucP = 0; ucP < uNumValores; ucP ++ )
      if ( pfValores [ ucP ] >= fValorSelec )
         return ucP;

   // pelo menos deve sempre encontrar o ultimo, ou eh bug
   printf ( "\nBUG: %s %d", __FILE__, __LINE__ );
   exit ( 0 );
   return 0;
}

